/*
Auteur : Xcxl
Date : lun. juin 29 2009
Role : Header de la classe par defaut

Gere les calcul vectoriels pour l'environnement et les camera
*/

#ifndef DEF_Coord3D
#define DEF_Coord3D

#include <cmath>

class Coord3D
{
        public:
                float X;
                float Y;
                float Z;

                Coord3D();
				Coord3D ( float x,float y,float z );
                Coord3D ( const Coord3D &v );
                Coord3D ( const Coord3D &from,const Coord3D &to );

                Coord3D & operator= ( const Coord3D & v );

                Coord3D & operator+= ( const Coord3D & v );

                Coord3D operator+ ( const Coord3D & v ) const;
                Coord3D operator+ ( const Coord3D *v );
				Coord3D & operator+ (const float a);

                Coord3D & operator-= ( const Coord3D & v );
                Coord3D operator- ( const Coord3D & v ) const;
				Coord3D & operator- (const float a);

				Coord3D & operator*= ( const float a );
				Coord3D operator* ( const float a ) const;
				friend Coord3D operator* ( const float a,const Coord3D & v );

				Coord3D & operator/= ( const float a );
				Coord3D operator/ ( const float a ) const;

                Coord3D crossProduct ( const Coord3D & v ) const;
				float distanceDroiteAuPoint(const Coord3D & pointDeLaDroite, const Coord3D & point)const;
				float length() const;
                Coord3D & normalize();
};

#endif
