/*
Auteur : Xcxl
Date : lun. aout 4 2008

Role : Classe principal du programme, elle contient les deux QGLwidget et c'est d'elle que l'on cre
		les objets le joueur. Elle gre surtout les entres souris/clavier, envoie les donnes recolts
		aux qglwidget ou au objet et appelle les updateGL priodiquement
Elle herite de QMainWindow


*/

#ifndef DEF_MAINWINDOW 
#define DEF_MAINWINDOW

#include <GL/gl.h>
#include <GL/glu.h>

#include <QMainWindow>
#include <QApplication>
#include <QHBoxLayout>
#include <QVBoxLayout>
#include <QPushButton>
#include <QLabel>
#include <QPoint>
#include <QCheckBox>
#include <QMenuBar>
#include <QProgressBar>
#include <QWidget>
#include <QSpacerItem>
#include <QString>
#include <QFile>
#include <QTimer>
#include <iostream>
#include <QDebug>
#include "OpenGLWidget.h"
#include "Objets.h"
#include "Coord3D.h"

#include <QStringList>

class MainWindow : public QMainWindow
{

Q_OBJECT

public:
	MainWindow();

private slots:
        void affichageDonnee(bool valeur = true);
        void affichageDuFPS();
        void affichageLabelFPS(bool valeur = false);
        void affichageMinicarte(bool valeur = true);
		void cycleTimerJeu();


private:

        void lancerJeu(); //lance les deux timers; rafraichissement de l'image et compteur de FPS
        void stopperJeu();
		void gestionArme();

        void mousePressEvent ( QMouseEvent * event );
        void mouseReleaseEvent ( QMouseEvent * event );
        void mouseMoveEvent(QMouseEvent *event);
        void wheelEvent(QWheelEvent *event); //roulette de la souris
        void keyPressEvent(QKeyEvent *event); //gestion des touches
        void keyReleaseEvent ( QKeyEvent * event );


        QTimer *timerJeu;
        QTimer *timerFPS;

		bool enPause;
		int _numCycle; //le nombre de cycle de timer, pour le calcul du FPS
		bool rafraichirData;
		bool minicarteActive;

	
		QWidget *zoneCentrale;
        QCheckBox *checkBoxMinicarte;
        QLabel *labelVitesse;
        QProgressBar *barVitesse;
        QLabel *labelVie;
        QProgressBar *barVie;
        QLabel *labelMunitions;
        QProgressBar *barMunitions;
		QLabel *labelChargeArme;
		QProgressBar *barChargeArme;
        QLabel *labelPresFPS;
        QLabel *labelFPS;
        QPushButton *quitter;

        OpenGLWidget *vuePrincipal;
        OpenGLWidget *miniCarte;
        Personnage *joueur;

		int _tailleTerrainX;
		int _tailleTerrainY;
        int nombreObjets;
        Objet *liste_objets[50]; //tableau de pointeur vers des objets
	
		bool anti_repetition;
		bool sourisSurWidget;
		QPoint oldPosSouris;
		QPoint newPosSouris;
		int x_ancien;
		int y_ancien;
	
	
}; 

#endif
